// Import the MIDI library
import themidibus.*; 
MidiBus myBus; 

// Small & medium circles 
ArrayList<ColourCircle> ccS = new ArrayList<ColourCircle>();
ArrayList<ColourCircle> ccB = new ArrayList<ColourCircle>();

// Variables to change the window size and spacing of the grid circles
int space = 100;
int s = 600;

// Variable for the "backout" at regular intervals
int flicker = 20;

// Instance for the big 
ColourCircle bigC = new ColourCircle(s/2, s/2, 150, 300, random(0, 300));

void setup() {
  //sets up the window and initial settings
  size(s, s);
  background(0);
  noStroke();
  frameRate(12);
 
  //picks up the MIDI controller
  myBus = new MidiBus(this, "Akai MPD26", 0);
 
  //populates the 2 circle arrays
  for(int y = 1; y < height/space; ++y){
   for(int x = 1; x < width/space; ++x){
     ColourCircle newC = new ColourCircle(x*space, y*space, 10, 4, random(0, 300));
     ccS.add(newC);
     
     ColourCircle newC1 = new ColourCircle(x*space, y*space, space, 8, random(0, 300));
     ccB.add(newC1);
   }
  } 
}

// the "draw" code is whats executed every frame
void draw(){
  
  // logic for "blackout"
  if(flicker > 0 && frameCount%flicker == 0){
    background(0);
  }
 
  // displays and updates all circles using MIDI input
  bigC.display();
  bigC.update(map(bigCMcontrol, 0, 127, 0.2, 3), bigCShow); // change the 3rd param of map to change speed of rotation
  for(int i = 0; i < ccS.size(); ++i){
    ccS.get(i).display();
    ccB.get(i).display();
    ccS.get(i).update(map(csMcontrol, 0, 127, 1, 1.5), csShow);// same as above
    ccB.get(i).update(map(cbMcontrol, 0, 127, 1, 1.5), cbShow);// same as above
  }
 
}